export function fragmentMatches(fragment, typename, possibleTypes) {
    if (!fragment.typeCondition) {
        return true;
    }
    var typeCondition = fragment.typeCondition.name.value;
    if (typename === typeCondition) {
        return true;
    }
    if (possibleTypes) {
        var workQueue = [possibleTypes[typeCondition]];
        for (var i = 0; i < workQueue.length; ++i) {
            var subtypes = workQueue[i];
            if (subtypes) {
                if (subtypes[typename] === true)
                    return true;
                for (var subtype in subtypes) {
                    var subsubtypes = possibleTypes[subtype];
                    if (subsubtypes && workQueue.indexOf(subsubtypes) < 0) {
                        workQueue.push(subsubtypes);
                    }
                }
            }
        }
        return false;
    }
    return 'heuristic';
}
//# sourceMappingURL=fragments.js.map