import { KeyTrie } from 'optimism';
import { Cache } from '../core';
import { DiffQueryAgainstStoreOptions, ReadQueryOptions, StoreObject } from './types';
export declare type VariableMap = {
    [name: string]: any;
};
export declare type ExecResultMissingField = {
    object: StoreObject;
    fieldName: string;
    tolerable: boolean;
};
export declare type ExecResult<R = any> = {
    result: R;
    missing?: ExecResultMissingField[];
};
declare type PossibleTypes = import('./inMemoryCache').InMemoryCache['possibleTypes'];
export interface StoreReaderConfig {
    addTypename?: boolean;
    cacheKeyRoot?: KeyTrie<object>;
    possibleTypes?: PossibleTypes;
}
export declare class StoreReader {
    private config;
    constructor(config?: StoreReaderConfig);
    readQueryFromStore<QueryType>(options: ReadQueryOptions): QueryType | undefined;
    diffQueryAgainstStore<T>({ store, query, variables, previousResult, returnPartialData, rootId, config, }: DiffQueryAgainstStoreOptions): Cache.DiffResult<T>;
    private executeStoreQuery;
    private executeSelectionSet;
    private executeField;
    private combineExecResults;
    private executeSubSelectedArray;
}
export {};
//# sourceMappingURL=readFromStore.d.ts.map