import { FieldNode, DocumentNode } from 'graphql';
import { FragmentMap } from '../../utilities';
import { IdGetter, NormalizedCache } from './types';
export declare type WriteContext = {
    readonly store: NormalizedCache;
    readonly processedData: {
        [x: string]: Set<FieldNode>;
    };
    readonly variables?: any;
    readonly dataIdFromObject?: IdGetter;
    readonly fragmentMap?: FragmentMap;
};
declare type PossibleTypes = import('./inMemoryCache').InMemoryCache['possibleTypes'];
export interface StoreWriterConfig {
    possibleTypes?: PossibleTypes;
}
export declare class StoreWriter {
    private config;
    constructor(config?: StoreWriterConfig);
    writeQueryToStore({ query, result, dataId, store, variables, dataIdFromObject, }: {
        query: DocumentNode;
        result: Object;
        dataId?: string;
        store?: NormalizedCache;
        variables?: Object;
        dataIdFromObject?: IdGetter;
    }): NormalizedCache;
    private writeSelectionSetToStore;
    private processSelectionSet;
    private processFieldValue;
}
export {};
//# sourceMappingURL=writeToStore.d.ts.map