import { asyncMap } from './observables';
export default function subscribeAndCount(done, observable, cb) {
    var handleCount = 0;
    var subscription = asyncMap(observable, function (result) {
        try {
            return cb(++handleCount, result);
        }
        catch (e) {
            setImmediate(function () {
                subscription.unsubscribe();
                done.fail(e);
            });
        }
    }).subscribe({
        error: done.fail,
    });
    return subscription;
}
//# sourceMappingURL=subscribeAndCount.js.map